typedef unsigned char byte;

byte RGB[256][3];
byte SRGB[256][3];
byte ORGB[256][3];


void setrgb(byte palnum, byte r, byte g, byte b);
void getrgb(byte palnum, byte *r, byte *g, byte *b);
void rotatergb(byte st, byte ed);
void savergb();
void saveorgrgb();
void restorergb();
void restoreorgrgb();

void setrgb(byte palnum, byte r, byte g, byte b)
{
  outportb(0x3c8,palnum);
  outportb(0x3c9,r);
  outportb(0x3c9,g);
  outportb(0x3c9,b);
}

void getrgb(byte palnum, byte *r, byte *g, byte *b)
{
  outportb(0x3c7, palnum);
  *r=inportb(0x3c9);
  *g=inportb(0x3c9);
  *b=inportb(0x3c9);
}

void rotatergb(byte st, byte ed)
{
  byte sr, sg, sb, r, g, b;
  int t;

  getrgb(ed, &sr, &sg, &sb);

  for (t=ed; t>st; t--) {
    getrgb(t-1, &r, &g, &b);
    setrgb(t, r, g, b);
  }

  setrgb(st, sr, sg, sb);
}

void savergb()
{
   int i;

   for (i=0; i<256; i++)
	 getrgb(i, &SRGB[i][0], &SRGB[i][1], &SRGB[i][2]);
}

void saveorgrgb()
{
   int i;

   for (i=0; i<256; i++)
	 getrgb(i, &ORGB[i][0], &ORGB[i][1], &ORGB[i][2]);
}

void restorergb()
{
   int i;

   for (i=0; i<256; i++)
	 setrgb(i, SRGB[i][0], SRGB[i][1], SRGB[i][2]);
}

void restoreorgrgb()
{
   int i;

   for (i=0; i<256; i++)
	 setrgb(i, ORGB[i][0], ORGB[i][1], ORGB[i][2]);
}
